Index: /qPloneTabs/trunk/HISTORY.txt
===================================================================
--- /qPloneTabs/trunk/HISTORY.txt	(revision 32)
+++ /qPloneTabs/trunk/HISTORY.txt	(revision 33)
@@ -1,2 +1,6 @@
+0.4.0
+
+  * now global_sections tabs updated asynchronous during changes on qPloneTabs ajax configlet
+
 0.3.1
 
Index: /qPloneTabs/trunk/README.txt
===================================================================
--- /qPloneTabs/trunk/README.txt	(revision 32)
+++ /qPloneTabs/trunk/README.txt	(revision 33)
@@ -1,6 +1,6 @@
 Quintagroup Plone Tabs
 
-  The product allows Plone websites to modify portal_tabs
-  actions from portal_control_panel form.
+  The product allows Plone websites to modify portal_actions tool
+  from portal_control_panel form.
 
   (c) "Quintagroup":http://quintagroup.com/ , 2006. 
Index: /qPloneTabs/trunk/skins/qPloneTabs/javascripts/qplonetabs.js
===================================================================
--- /qPloneTabs/trunk/skins/qPloneTabs/javascripts/qplonetabs.js	(revision 32)
+++ /qPloneTabs/trunk/skins/qPloneTabs/javascripts/qplonetabs.js	(revision 33)
@@ -45,4 +45,5 @@
            Sortable.destroy('tabslist');
            new Effect.Highlight('tabslist',{});
+           updateGlobalSections();
          },
          onComplete: function(request){Behaviour.apply();}
@@ -88,4 +89,5 @@
                 Element.addClassName(li, 'invisible');
               };
+              updateGlobalSections();
             },
             onFailure: function(request){
@@ -128,4 +130,5 @@
              };
            }});
+           updateGlobalSections();
          }
         }
@@ -185,5 +188,6 @@
                   Behaviour.apply();
                 }
-              })
+              });
+              updateGlobalSections();
             },
             onFailure: function(request){
@@ -265,4 +269,5 @@
                }
              });
+             updateGlobalSections();
            },
            onFailure: function(request){
@@ -302,4 +307,5 @@
               el.attachEvent?ieHover():'';
               Behaviour.apply();
+              updateGlobalSections();
             }
           });
@@ -400,4 +406,16 @@
 
 
+// API for updating global_sections tabs
+
+function updateGlobalSections() {
+    new Ajax.Updater({success : 'portal-globalnav'}, 'qpt_globalsections', {
+            method : 'post',
+            onSuccess : function(){
+              new Effect.Highlight('portal-globalnav', {});
+            }
+    });
+}
+
+
 //**********************************************
 
Index: /qPloneTabs/trunk/skins/qPloneTabs/prefs_tabs_form.cpt
===================================================================
--- /qPloneTabs/trunk/skins/qPloneTabs/prefs_tabs_form.cpt	(revision 32)
+++ /qPloneTabs/trunk/skins/qPloneTabs/prefs_tabs_form.cpt	(revision 33)
@@ -10,8 +10,12 @@
 <head>
   <metal:javascript_head_slot fill-slot="javascript_head_slot">
-        <script type="text/javascript" src="javascripts/prototype.js"></script>
-        <script type="text/javascript" src="javascripts/scriptaculous.js"></script>
-        <script type="text/javascript" src="javascripts/behaviour.js"></script>
-        <script type="text/javascript" src="javascripts/qplonetabs.js"></script>
+        <script type="text/javascript" src="javascripts/prototype.js"
+                tal:attributes="src string:${portal_url}/${attrs/src}"></script>
+        <script type="text/javascript" src="javascripts/scriptaculous.js"
+                tal:attributes="src string:${portal_url}/${attrs/src}"></script>
+        <script type="text/javascript" src="javascripts/behaviour.js"
+                tal:attributes="src string:${portal_url}/${attrs/src}"></script>
+        <script type="text/javascript" src="javascripts/qplonetabs.js"
+                tal:attributes="src string:${portal_url}/${attrs/src}"></script>
   </metal:javascript_head_slot>
   <metal:cssslot fill-slot="css_slot">
Index: /qPloneTabs/trunk/skins/qPloneTabs/qpt_globalsections.pt
===================================================================
--- /qPloneTabs/trunk/skins/qPloneTabs/qpt_globalsections.pt	(revision 33)
+++ /qPloneTabs/trunk/skins/qPloneTabs/qpt_globalsections.pt	(revision 33)
@@ -0,0 +1,25 @@
+<tal:defs define="dummy python:request.RESPONSE.setHeader('Expires', 'Mon, 26 Jul 1996 05:00:00 GMT')">
+
+<metal:block use-macro="here/global_defines/macros/defines" />
+
+<div metal:define-macro="portal_tabs"
+     tal:omit-tag=""
+     tal:define="selected_tabs python:here.selectedTabs('index_html', here, portal_tabs);
+                 selected_portal_tab selected_tabs/portal;"
+     tal:condition="portal_tabs">
+
+    <tal:tabs tal:repeat="tab portal_tabs">
+        <li tal:attributes="id string:portaltab-${tab/id};
+                            class python:test(selected_portal_tab==tab['id'], 'selected', 'plain');">
+            <a href=""
+               tal:content="tab/name"
+               tal:attributes="href tab/url;
+                               title tab/description|nothing">
+                Tab Name
+            </a>
+        </li>
+    </tal:tabs>
+
+</div>
+
+</tal:defs>
Index: /qPloneTabs/trunk/version.txt
===================================================================
--- /qPloneTabs/trunk/version.txt	(revision 32)
+++ /qPloneTabs/trunk/version.txt	(revision 33)
@@ -1,1 +1,1 @@
-0.3.1
+0.4.0