Index: /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/plonetabs.py
===================================================================
--- /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/plonetabs.py	(revision 159)
+++ /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/plonetabs.py	(revision 160)
@@ -458,5 +458,5 @@
         
         # check reorder controls, whether we should hide them
-        self.kss_checkReorderControls(cat_name)
+        #self.kss_checkReorderControls(cat_name)
         
         # issue portal message
@@ -487,5 +487,5 @@
             
             # update reorder controls
-            self.kss_checkReorderControls(cat_name)
+            #self.kss_checkReorderControls(cat_name)
             
             # hide adding form
Index: /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/resources/plonetabs.css
===================================================================
--- /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/resources/plonetabs.css	(revision 159)
+++ /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/resources/plonetabs.css	(revision 160)
@@ -4,4 +4,6 @@
 /*
 ***************************************************************************************************
+*                                                                                                 *
+*   This doc is outdated now, don't read it!!!                                                    *
 *                                                                                                 *
 *   There are two global self-excluding classes: 'viewing' and 'sorting',                         *
@@ -26,70 +28,59 @@
 */
 
-.kssTabsActive #app.viewing         .reorder-controls,
-.kssTabsActive #app.sorting         .sort-controls,
-/* #app.viewing li.editing          .editform, */
-#app.viewing li.editing             .edit-fields-wrapper,
-#app #addaction.adding              .field-visible,
-#app #addaction.adding              .field-name dt,
-#app #addaction.adding              .field-action,
-/* fix for 'non js' version 
-#app #addaction.adding              .field-action label,*/
-#app #addaction                     .field-action label,
-.kssTabsActive #app #addaction.adding              .collapseAdvanced,
-#app #addaction.adding              .field-id,
-#app #addaction.adding              .field-condition,
-#app #addaction.adding              .add-controls,
-.kssTabsActive #app.viewing #tabslist li      .url-helper,
-.kssTabsActive #app.viewing #tabslist li      .tab-title,
-.kssTabsActive #app                           .editcancel {
+#app li.editing                            .edit-fields-wrapper,
+#app #addaction                            .field-action label,
+#app #addaction.adding                     .field-visible,
+#app #addaction.adding                     .field-name dt,
+#app #addaction.adding                     .field-action,
+#app #addaction.adding                     .field-id,
+#app #addaction.adding                     .field-condition,
+#app #addaction.adding                     .add-controls,
+
+.kssTabsActive #app                        .editcancel,
+.kssTabsActive #app #tabslist li           .url-helper,
+.kssTabsActive #app #tabslist li           .tab-title,
+.kssTabsActive #app #addaction.adding      .collapseAdvanced {
     display: block;
 }
 
-#app                                #busy,
-#app.viewing                        .noitems,
-#app                                .reorder-controls,
-#app                                .sort-controls,
-
-/* fix for 'non js' version */
-#app.viewing #tabslist li           .url-helper,
-#app.viewing #tabslist li           .tab-title,
-.kssTabsActive #app.viewing #tabslist li.editing      .url-helper,
-.kssTabsActive #app.viewing #tabslist li.editing      .tab-title,
-
-#app                                .drag-handle,
-#app                                .delete,
-.kssTabsActive #app                 .visibility,
-/* .kssTabsActive #app                 .editform, */
-.kssTabsActive #app                 .edit-fields-wrapper,
-.kssTabsActive #app                 .editdelete,
-.kssTabsActive #app                 .editreset,
-#app.sorting                        #addaction,
-.kssTabsActive #app                 .field-visible,
-.kssTabsActive #app                 .field-name dt,
-.kssTabsActive #app                 .field-action,
-.kssTabsActive #app #addaction                 .collapseAdvanced,
-.kssTabsActive #app                 .field-id,
-.kssTabsActive #app                 .field-condition,
-.kssTabsActive #app                 .add-controls,
-.kssTabsActive #app                 .change-button,
-#app                                .editcancel {
+
+#app                                       .drag-handle,
+#app                                       .delete,
+#app                                       .editcancel,
+#app #tabslist li                          .url-helper,
+#app #tabslist li                          .tab-title,
+
+.kssTabsActive #app                        .visibility,
+.kssTabsActive #app                        .edit-fields-wrapper,
+.kssTabsActive #app                        .editdelete,
+.kssTabsActive #app                        .editreset,
+.kssTabsActive #app                        .field-visible,
+.kssTabsActive #app                        .field-name dt,
+.kssTabsActive #app                        .field-action,
+.kssTabsActive #app                        .field-id,
+.kssTabsActive #app                        .field-condition,
+.kssTabsActive #app                        .add-controls,
+.kssTabsActive #app                        .change-button,
+.kssTabsActive #app #addaction             .collapseAdvanced,
+.kssTabsActive #app #tabslist li.editing   .url-helper,
+.kssTabsActive #app #tabslist li.editing   .tab-title {
     display: none;
 }
 
-#app.working #busy,
-.kssTabsActive #app.viewing ul.csshover li:hover    .delete,
-.kssTabsActive #app.viewing ul.csshover li.onHover  .delete,
-#app.viewing ul.csshover li:hover    .visibility,
-#app.viewing ul.csshover li.onHover  .visibility,
-.kssTabsActive #app.viewing ul.csshover li:hover    .drag-handle,
-.kssTabsActive #app.viewing ul.csshover li.onHover  .drag-handle,
-#app ul#roottabs.csshover li:hover   .visibility,
-#app ul#roottabs.csshover li.onHover .visibility
-/* #app.sorting                         .drag-handle*/ {
+
+#app ul.csshover li:hover                  .visibility,
+#app ul.csshover li.onHover                .visibility,
+#app ul#roottabs.csshover li:hover         .visibility,
+#app ul#roottabs.csshover li.onHover       .visibility,
+
+.kssTabsActive #app ul.csshover li:hover   .delete,
+.kssTabsActive #app ul.csshover li.onHover .delete,
+.kssTabsActive #app ul.csshover li:hover   .drag-handle,
+.kssTabsActive #app ul.csshover li.onHover .drag-handle {
     display: inline;
 }
 
 /**********************************************************/
-/* Additional style for functionality withou javascript   */
+/* Additional style for functionality without javascript   */
 .kssTabsActive #autogeneration_controls {
     display: none;
@@ -119,5 +110,5 @@
 
 #app .invisible span.tab-title {
-    color:#aaa;
+    color: #aaa;
 }
 
@@ -130,9 +121,4 @@
 #app #autogeneration_section {
     margin-top: 1em;
-}
-
-div.reorder-controls,
-div.sort-controls {
-    float:left;
 }
 
@@ -146,5 +132,5 @@
     list-style-type: none;
     list-style-image: none;
-    margin:2.5em 0 0 1.7em;
+    margin-left: 1.7em;
 }
 
@@ -225,8 +211,4 @@
 }
 
-#app.sorting ul.csshover li.editing {
-    padding: 0 0.5em;
-}
-
 #app li.editing form {
     margin:-0.1em;
@@ -314,6 +296,6 @@
 /*hover***************************************************/
 
-.kssTabsActive #app.viewing ul#tabslist.csshover li:hover,
-.kssTabsActive #app.viewing ul#tabslist.csshover li.onHover {
+.kssTabsActive #app ul#tabslist.csshover li:hover,
+.kssTabsActive #app ul#tabslist.csshover li.onHover {
     background-color: #FFFFDD;
     border: 1px inset threedface;
@@ -321,5 +303,5 @@
 }
 
-.kssTabsActive #app.viewing ul#tabslist.csshover li.editing {
+.kssTabsActive #app ul#tabslist.csshover li.editing {
     background-color: White;
     border: 1px solid white;
Index: /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/plonetabs.pt
===================================================================
--- /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/plonetabs.pt	(revision 159)
+++ /qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/plonetabs.pt	(revision 160)
@@ -20,5 +20,5 @@
 <div id="plonetabs_form">
 
-<div id="app" class="viewing">
+<div id="app">
 
   <h1 class="documentFirstHeading">
@@ -26,5 +26,4 @@
       <tal:title replace="python:view.getPageTitle(category)">Plone Tabs</tal:title>
     </span>
-    <span id="busy"><img src="++resource++busy_icon.gif" alt="" tal:attributes="src string:${portal_url}/${attrs/src}" /></span>
   </h1>
 
@@ -63,15 +62,4 @@
       </div>
     </form>
-  </div>
-
-  <div class="reorder-controls"
-       tal:define="notempty python:view.hasActions(category)">
-    <a href="#" id="reorder" class=""
-       tal:attributes="class python:test(notempty, '', 'noitems')">Reorder</a>
-  </div>
-
-  <div class="sort-controls">
-    <a href="#" id="save">Save</a> |
-    <a href="#" id="cancel">Cancel</a>
   </div>
 